<?php

namespace App\Http\Controllers;

use App\Models\Restaurante;
use App\Models\Sector;
use App\Services\PaginatorService;
use App\Services\UuidService;
use App\Exceptions\GenericException;
use App\Exceptions\CantdeletehasChild;
use App\Exceptions\ModelNotFoundException;
use Illuminate\Http\JsonResponse;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Ramsey\Uuid\Uuid;

class SectoresController extends Controller {

    /**
     * Obtiene de forma paginada los sectores registrados en el backend
     */
    public function all(Request $request, $restaurante_id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        $restaurante = Restaurante::findOrFail($restaurante_id);

        $sectores = $restaurante->sectores();

        $paginate = app(PaginatorService::class)->paginate(
            perPage: $request->input('per_page', 15),
            page: $request->input('page', 1),
            total: $sectores->count(),
            route: 'restaurant.all',
            data: ['restaurante_id' => $restaurante_id]
        );

        $data = $sectores->get()
                         ->skip($paginate['from'] - 1)
                         ->take($paginate['per_page'])
                         ->all();

        return response()->json([
            'pagination' => $paginate,
            'data' => $data
        ]);
    }

    /**
     * Obtiene un sector por su id
     */
    public function get(Request $request, $restaurante_id, $id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        app(UuidService::class)->validOrFail($id);

        $restaurante = Restaurante::findOrFail($restaurante_id);
        $sector = Sector::findOrFail($id);

        if($sector->restaurante != $restaurante) {
            throw new ModelNotFoundException("sector", $id);
        }

        return response()->json($sector);
    }

    /**
     * Crea un nuevo sector
     */
    public function create(Request $request, $restaurante_id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        $restaurante = Restaurante::findOrFail($restaurante_id);

        $this->validate($request, [
            'nombre' => 'required'
        ]);

        $sector = Sector::create([
            'id' => Uuid::uuid4(),
            'nombre' => $request->input('nombre'),
            'restaurante_id' => $restaurante->id
        ]);

        return response()->json($sector, 201);
    }

    /**
     * Actualiza un sector
     */
    public function update(Request $request, $restaurante_id, $id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        app(UuidService::class)->validOrFail($id);

        $this->validate($request, [
            'nombre' => 'required'
        ]);

        $restaurante = Restaurante::findOrFail($restaurante_id);
        $sector = Sector::findOrFail($id);

        if($sector->restaurante != $restaurante) {
            throw new ModelNotFoundException("sector", $id);
        }

        $sector->nombre = $request->input('nombre');
        $sector->save();

        return response()->json($sector);
    }

    /**
     * Elimina un sector
     */
    public function delete(Request $request, $restaurante_id, $id) {
        app(UuidService::class)->validOrFail($restaurante_id);
        app(UuidService::class)->validOrFail($id);

        $restaurante = Restaurante::findOrFail($restaurante_id);
        $sector = Sector::findOrFail($id);

        if($sector->restaurante != $restaurante) {
            throw new ModelNotFoundException("sector", $id);
        }

        if($sector->canalesVenta()->count() > 0) {
            throw new CantDeleteHasChildException("sector", "canal_venta");
        }

        $sector->delete();

        return response()->json([], 204);
    }
}
